﻿using System;
using Mehroz;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace AlgorithmBehaviorUnitTests {
  [TestClass]
  public class FractionTest {

    [TestMethod]
    public void TestPrecision() {
      double testDouble1 = 1234.56789;
      float testFloat1 = 1234.56789F;
      Fraction testFraction1 = new Fraction(testDouble1);

      Assert.AreEqual(testDouble1, testFraction1.ToDouble(5));

      for (int i = 0; i < 100; i++) {
        testDouble1 *= 10;
        testFraction1 *= 10;
        testFloat1 *= 10;

        Console.WriteLine("testDouble1 in " + i + " iteration: \t\t\t\t" + String.Format("{0:F5}", testDouble1));
        Console.WriteLine("testFloat1 in " + i + " iteration: \t\t\t\t" + String.Format("{0:F5}", testFloat1));
        Console.WriteLine("testFraction1 (ToDouble(5)) in " + i + " iteration: \t" + String.Format("{0:F5}", testFraction1.ToDouble(5)));
        Console.WriteLine("testFraction1 (ToString()) in " + i + " iteration: \t\t" + testFraction1.ToString());
        Console.WriteLine();
      }
    }
  }
}
